#include "Arduino.h"
#include "CLED.h"
#include <SPI.h>
// *************************** CLED ********************************
/*val1_6	  BGR 	color
       0    0:000	off
	   1    1:001	Red
	   2	3:011	yellow
	   3	2:010	Green
	   4	6:110	light blue
	   5	4:100	Blue
	   6	5:101	purple
	  (7	7:111	white) */
const byte CLED::color[8] = {0, 1, 3, 2, 6, 4, 5, 7};
const int CLED::INDI_CNT = 700;							// indicator counter
// *************************** GPIO ********************************
extern const int SEL_SEN;      							// 10:power off while LED on
extern const int FIX_CLED;      						// 12:FIX_CLED
extern int OE_CLED;      			 					// 13,OE_CLED
extern const int PWM_CLED;								// 14:PWM_CLED

CLED::CLED(int dmy):inCnt(0),inOn(false) {				// dmy: Error countermeasures
	digitalWrite(SEL_SEN, HIGH);
}
void CLED::set(byte* pAry, bool isInd) { 				// 1-12[8]:{7, 3,..}
	if (isInd) {										// *** blink indicator ***
		int indiCnt = INDI_CNT << ((inOn) ? 0 : 2);
		if (++inCnt == indiCnt) {						
			inCnt = 0;
			inOn = !inOn;
		}
	}
// ****************************
	unsigned long val24 = 0;
	bool isCledOn = false;
	for (int col = 0; col < COL_LEN; col++) { 			// LED number is opposit direction
		isCledOn |= (pAry[col] > 0);
		bool indiOn = isInd && inOn && (col == COL_LEN - 1) && (!isCledOn);	// indicator 
		byte val1_6 = indiOn ? 6 : pAry[col];
		val24 += (unsigned long)color[val1_6] << col * 3;
	}
	digitalWrite(SEL_SEN, LOW);
	digitalWrite(OE_CLED, LOW);        
	digitalWrite(SS, LOW);
	for (int b = 2; b>=0; b--) {
		SPI.transfer((val24 >> b * COL_LEN) & 0xff);
	}
	digitalWrite(FIX_CLED, HIGH);
	digitalWrite(FIX_CLED, LOW);      
	digitalWrite(SS, HIGH);
	digitalWrite(OE_CLED, HIGH);
}

void CLED::set(byte val1_6) {
    byte ary[COL_LEN];
    for (int i=0; i<COL_LEN; i++)
        ary[i] = val1_6;
    set(ary);
}